      subroutine ix9(next,nexh,nhel,n,indx)
c----------------------------------------------------------------------c
c Rearranges elements of the building block arrays into a correct order,
c for up to 12 particles
c
c Input: next - No of eternal particles,
c        nexh - No of polarization states of external particles,
c        nhel - No of all helicity states,
c        n(npart) - permutation of npart external particles
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 14 June, 2007; modified on 
c----------------------------------------------------------------------c

      implicit none

      integer :: next,nexh(next),nhel,
     &           i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,
     &           k1,k2,k3,k4,k5,k6,k7,k8,k9,
     &           indx(nhel),ix,i,ii(12)

      integer, dimension(next) :: nn
      integer, dimension(9) :: j,n
      integer, dimension(8) :: d
 
      do i=1,next
       nn(i)=nexh(i)
      end do

      j=0
      ix=0

      if (next == 11) then

      do i1=1,nn(1)
      do i2=1,nn(2)
      do i3=1,nn(3)
      do i4=1,nn(4)
      do i5=1,nn(5)
      do i6=1,nn(6)
      do i7=1,nn(7)
      do i8=1,nn(8)
      do i9=1,nn(9)
      do i10=1,nn(10)
      do i11=1,nn(11)

      ix=ix+1

      ii(1:11)=(/i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11/)

      do k1=1,next
       if (n(1) == k1) then
        j(1)=ii(k1)-1
        d(1)=nn(k1)
        do k2=1,next
         if (n(2) == k2) then
          j(2)=ii(k2)-1
          d(2)=nn(k2)
          do k3=1,next
           if (n(3) == k3) then
            j(3)=ii(k3)-1
            d(3)=nn(k3)
            do k4=1,next
             if (n(4) == k4) then
              j(4)=ii(k4)-1
              d(4)=nn(k4)
              do k5=1,next
               if (n(5) == k5) then
                j(5)=ii(k5)-1
                d(5)=nn(k5)
                do k6=1,next
                 if (n(6) == k6) then
                  j(6)=ii(k6)-1
                  d(6)=nn(k6)
                  do k7=1,next
                   if (n(7) == k7) then
                    j(7)=ii(k7)-1
                    d(7)=nn(k7)
                    do k8=1,next
                     if (n(8) == k8) then
                      j(8)=ii(k8)-1
                      d(8)=nn(k8)
                      do k9=1,next
                       if (n(9) == k9) then
                        j(9)=ii(k9)-1
                       end if
                      end do
                     end if
                    end do
                   end if
                  end do
                 end if
                end do
               end if
              end do
             end if
            end do
           end if
          end do
         end if
        end do
       end if
      end do

      indx(ix)=1
     &        +j(1)
     &        +j(2)*d(1)
     &        +j(3)*d(1)*d(2)
     &        +j(4)*d(1)*d(2)*d(3)
     &        +j(5)*d(1)*d(2)*d(3)*d(4)
     &        +j(6)*d(1)*d(2)*d(3)*d(4)*d(5)
     &        +j(7)*d(1)*d(2)*d(3)*d(4)*d(5)*d(6)
     &        +j(8)*d(1)*d(2)*d(3)*d(4)*d(5)*d(6)*d(7)
     &        +j(9)*d(1)*d(2)*d(3)*d(4)*d(5)*d(6)*d(7)*d(8)

      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do

      else if (next == 12) then

      do i1=1,nn(1)
      do i2=1,nn(2)
      do i3=1,nn(3)
      do i4=1,nn(4)
      do i5=1,nn(5)
      do i6=1,nn(6)
      do i7=1,nn(7)
      do i8=1,nn(8)
      do i9=1,nn(9)
      do i10=1,nn(10)
      do i11=1,nn(11)
      do i12=1,nn(12)

      ix=ix+1

      ii(1:12)=(/i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12/)

      do k1=1,next
       if (n(1) == k1) then
        j(1)=ii(k1)-1
        d(1)=nn(k1)
        do k2=1,next
         if (n(2) == k2) then
          j(2)=ii(k2)-1
          d(2)=nn(k2)
          do k3=1,next
           if (n(3) == k3) then
            j(3)=ii(k3)-1
            d(3)=nn(k3)
            do k4=1,next
             if (n(4) == k4) then
              j(4)=ii(k4)-1
              d(4)=nn(k4)
              do k5=1,next
               if (n(5) == k5) then
                j(5)=ii(k5)-1
                d(5)=nn(k5)
                do k6=1,next
                 if (n(6) == k6) then
                  j(6)=ii(k6)-1
                  d(6)=nn(k6)
                  do k7=1,next
                   if (n(7) == k7) then
                    j(7)=ii(k7)-1
                    d(7)=nn(k7)
                    do k8=1,next
                     if (n(8) == k8) then
                      j(8)=ii(k8)-1
                      d(8)=nn(k8)
                      do k9=1,next
                       if (n(9) == k9) then
                        j(9)=ii(k9)-1
                       end if
                      end do
                     end if
                    end do
                   end if
                  end do
                 end if
                end do
               end if
              end do
             end if
            end do
           end if
          end do
         end if
        end do
       end if
      end do

      indx(ix)=1
     &        +j(1)
     &        +j(2)*d(1)
     &        +j(3)*d(1)*d(2)
     &        +j(4)*d(1)*d(2)*d(3)
     &        +j(5)*d(1)*d(2)*d(3)*d(4)
     &        +j(6)*d(1)*d(2)*d(3)*d(4)*d(5)
     &        +j(7)*d(1)*d(2)*d(3)*d(4)*d(5)*d(6)
     &        +j(8)*d(1)*d(2)*d(3)*d(4)*d(5)*d(6)*d(7)
     &        +j(9)*d(1)*d(2)*d(3)*d(4)*d(5)*d(6)*d(7)*d(8)

      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do
      end do

      else 

      write(*,*)'ixkk.f: This value of next is not yet implemented',next

      end if


      end




