      subroutine svvmd_qp(g,u1,u2,u3,mat)
c----------------------------------------------------------------------c
c Returns a matrix element array for the triple gauge-Higgs boson  
c coupling
c
c Input: u1,u2 - vectors,
c        u3 -sclar
c        g - a Higgs-gauge-boson coupling.
c All four momenta are cosidered as incoming to the vertex.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 14 May, 2007; modified 
c 23 Feb. 2021: QP version
c----------------------------------------------------------------------c

      implicit none

      integer, parameter :: dp=kind(1.d0),qp=kind(1.q0)
      complex(dp) :: g
      complex(qp) :: u2(0:3),u3(0:3),u1,mat

      mat=g*u1*(u3(0)*u2(0)-u3(1)*u2(1)-u3(2)*u2(2)-u3(3)*u2(3))

      end subroutine svvmd_qp
