c;;;;;;;;;;;;;;;;;;;;;;;;;;;;; -*- Mode: Fortran -*- ;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; fpi2rnew.f --- 
c;; Author          : Fred Jegerlehner
c;; Created On      : Thu May  1 23:40:25 2008
c;; Last Modified By: Friedrich Jegerlehner
c;; Last Modified On: Thu Dec 23 01:25:58 2010
c;; RCS: $Id$
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; Copyright (C) 2008 Fred Jegerlehner
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; 
      function fpikk(s)
c    PION FORM FACTOR  (absolute)
c CMD-2 parametrization December 2001; update August 2003    
c version extended by rho--omega mixing flag iso : 
c iso=1 calculate I=1 part only (omega switched off), iso=0 I=0 part else sum
c 01/08/2008 new option for energy dependent widths
c iopt=12 rho only quadratic, 32 all 3 rho's quadratic 
c iopt=11 rho only linear, 31 all 3 rho's linear
c iopt anything else [0,1,...] old CMD-2 version = iopt=11 
c ------------------- Changes by Karol Kolodziej, 9 Feb. 2016 -----------------
c The charged pion mass mpi is transferred through module inprms. 
c Common block DASE and some parameters have been moved to module dase.
c A command if (ini == 0) then has been shifted.
c Note that all masses, widths and s in this function are in MeV.
c-------------------------------------------------------------------------------

      use dase
      use inprms
      implicit none
      complex(dp), parameter :: cI=(0.d0,1.d0),
     &                          cone=(1.d0,0.d0)
      integer :: ini=0,i
      complex(dp) cdels,cepdom,cbeta,cgama,cnorm,cfpis,cfpis1,
     &            cBWnu,cBWde,cBWGSr0,cBWGSr1,cBWom,cBWGSr(3),fpikk
      real(dp) fpi2kk,fpi2rnew1,fpi2rnewtot,fpi2rnewie1,
     &         s,e,xp,rats,beps,ppis,lgs,hs,ratm,bepm,ppim,lgm,hm,
     &         dhdsm,fs,d,grs,rBWnu
      real(dp) a(np),mrh(3),grho(3),mr,gr,mp2,mr2,mo2,mr4,
     &     beta,phibeta,delta,phidelta,deltaarg,betaarg,gamaarg
      real(dp) dmro(3),dgro(3),ddelta,dphidel,dbeta,dphibet,
     &     gamma,dgama,phigama,dphigam,momega,dmomega,gomega,dgomega,
     &     mpic,mpc,mo,go
      save

      s=s*1.d6

      if (DSET.ne.'WAVE') DSET='CMD2'
c      DSET='WAVE'
c Constants, Parameters
c      alp=1.D0/137.035999084D0  ! pm (51) April 2008
C CMD-2 Fit parameters 2003 PDG 2006
c      mpi0  =134.9766           !+/- 0.0006  neutral pion
c      mpi    =139.57018d0     !+/- 0.00035  mass of charged pion
      mpic    =mpi*1.d3     !+/- 0.00035  mass of charged pion
ckk>
c      mrh(1)=775.5d0         ! PDG 2006
c      dmro(1)=0.4d0           
c      grho(1)=143.85d0
c      dgro(1)=1.5d0           
c      mrh(2)=1446.0d0    ! take values from Belle fit
c      dmro(2)=29.0d0          
c      grho(2)=434.0d0
c      dgro(2)=62.0d0          
ckk<
c      mrh(2)=1459.0d0      ! PDG 2008
c      dmro(2)=11.0d0          
c      grho(2)=171.0d0
c      dgro(2)=50.0d0         

      if (ini == 0) then 
 
      mrh(3)=1728.8d0      ! take values from Belle fit
      dmro(3)=91.0d0
      grho(3)=193.0d0        
      dgro(3)=62.0d0
c      mrh(3)=1688.8d0    ! PDG 2006
c      dmro(3)=2.1d0
c      grho(3)=161.0d0        
c      dgro(3)=10.0d0
      delta =1.57d-3            ! CMD2 2002 not changed  (ckeck 2008)
      ddelta=0.16d-3         ! +/- 0.15d-3 +/- 0.05d-3   modulus of delta
      phidelta=10.4d0        ! CMD2 hep-ex/0610021v3
      dphidel=3.8d0           ! +/- 1.6 +/- 3.5       phase angle in degrees
c      beta   =0.0859d0        ! CMD2 hep-ex/0610021v3
      beta   =0.08d0        ! CMD2 hep-ex/0610021v3
      dbeta  =0.0040d0        ! +/-  .0030 +/- .0027
      phibeta=180.0d0
      dphibet=10.0d0
c      gama   =0.000d0         ! */-  0.009
      gamma   =0.028d0         ! */-  0.009
      dgama  =0.028d0
      phigama=24.000d0
      dphigam=24.000d0
      momega =782.65d0       ! +/- 0.12 PDG 2004/2006
      dmomega=000.12d0      
      gomega =  8.49d0         ! +/- 0.08  PDG 2004/2006
      dgomega=  0.08d0  

c CMD2 fit May 2008 chi^2=29/51 and S=0.7; incl. SND would give 159/51 and S=1.7
      if (DSET.eq.'CMD2') then
      a(1)=7.7437D+02  
      a(2)=1.4421D+02  
      a(3)=9.9859D-02
      a(4)=1.8000D+02  
      a(5)=1.4460D+03  
      a(6)=4.3400D+02
      a(7)=1.8300D-03  
      a(8)=1.0600D+01
      else if (DSET.eq.'WAVE') then
      a(1)=7.7449D+02  
      a(2)=1.5063D+02  
      a(3)=1.2615D-01
      a(4)=1.8000D+02  
      a(5)=1.4460D+03  
      a(6)=4.3400D+02
      a(7)=1.988D-03  
      a(8)=0.900D+01
      endif
c      a(1)=7.7359D+02    ! mrh(1)   
c      a(2)=1.4305D+02    ! grho(1) 
c      a(3)=9.2313D-02    ! beta    
c      a(4)=1.8000D+02    ! phibeta 
c      a(5)=1.4590D+03    ! mrh(2) 
c      a(6)=1.7100D+02    ! grho(2) 
c      a(7)=1.5700D-03    ! delta   
c      a(8)=1.0400D+01    ! phidelta
      ini=1
c      endif

      mrh(1) =a(1)
      grho(1) =a(2)
      beta    =a(3)
      phibeta =a(4)
      mrh(2) =a(5)
      grho(2) =a(6)
      delta   =a(7)
      phidelta=a(8)
      
      mpc=mpic
      mo=momega
      go=gomega
 
      mp2  =mpc*mpc
      mo2  =mo*mo

      endif

c Auxiliary variables
      e    =dsqrt(s)
      xp   =4.d0*mp2
      rats =xp/s
      beps =dsqrt(1.d0-rats)
      ppis =0.5d0*e *beps
      lgs  =dlog((e +2.d0*ppis)/(2.d0*mpc))
      hs   =2.d0/pi*ppis/e *lgs
      do i=1,3 
        mr   =mrh(i)
        gr   =grho(i)
        mr2  =mr *mr
        mr4  =mr2*mr2
        ratm =xp/mr2
        bepm =dsqrt(1.d0-ratm)
        ppim =0.5d0*mr*bepm
        lgm  =dlog((mr+2.d0*ppim)/(2.d0*mpc))
        hm   =2.d0/pi*ppim/mr*lgm
        dhdsm=hm*(0.125d0/ppim**2-0.5d0/mr2)+0.5d0/pi/mr2
        fs   =gr*mr2/ppim**3*(ppis**2*(hs-hm)+(mr2-s)*ppim**2*dhdsm)
        d    =3.d0/pi*mp2/ppim**2*lgm+mr/2.d0/pi/ppim-mp2*mr/pi/ppim**3
        if (iopt.eq.11) then
           if (i.eq.1) then
c     GS parametrization R.R. Akhmetshin hep-ex/9904027 take linear mr/e factor
c     in Belle 2008 M.~Fujikawa et al arXiv:0805.3773 [hep-ex] fit a quadratic (mr/e)**2 dependence is assumed
c     only rho taken with energy dependent width
c     changed from linear to quadratic mr/e 24/06/2008
              grs=gr*(ppis/ppim)**3*(mr/e)
           else 
              grs=gr
           endif
c option used by Belle 2008 all 3 rho's have same type of energy dependent with
        else if (iopt.eq.31) then
           grs=gr*(ppis/ppim)**3*(mr/e)
        else if (iopt.eq.12) then
           if (i.eq.1) then
c     GS parametrization R.R. Akhmetshin hep-ex/9904027 take linear mr/e factor
c     in Belle 2008 M.~Fujikawa et al arXiv:0805.3773 [hep-ex] fit a quadratic (mr/e)**2 dependence is assumed
c     only rho taken with energy dependent width
c     changed from linear to quadratic mr/e 24/06/2008
              grs=gr*(ppis/ppim)**3*(mr/e)**2
           else 
              grs=gr
           endif
c option used by Belle 2008 all 3 rho's have same type of energy dependent with
        else if (iopt.eq.32) then
           grs=gr*(ppis/ppim)**3*(mr/e)**2
        else
c original CMD-2 fit version
           if (i.eq.1) then
              grs=gr*(ppis/ppim)**3*(mr/e)
           else 
              grs=gr
           endif           
        endif
        rBWnu=mr2*(1.d0+d*gr/mr)
        cBWnu=DCMPLX(rBWnu,0.D0)
        cBWde=DCMPLX(mr2-s+fs,-mr*grs)
        cBWGSr(i)=cBWnu/cBWde
      enddo  
c delta argument in radians       
      deltaarg=phidelta*2.d0*pi/360.d0
      gamaarg=phigama*2.d0*pi/360.d0
      cdels =DCMPLX(dcos(deltaarg),dsin(deltaarg))*
     &       DCMPLX(delta*s/mo2,0.d0)
      cBWom =DCMPLX(mo2,0.d0)/DCMPLX(mo2-s,-mo*go)
      cepdom=cone+cdels*cBWom
      betaarg=phibeta*2.d0*pi/360.d0
      cbeta =DCMPLX(dcos(betaarg),dsin(betaarg))*
     &       DCMPLX(beta,0.d0)
      cgama =DCMPLX(dcos(gamaarg),dsin(gamaarg))*
     &       DCMPLX(gamma,0.d0)
      cnorm =cone+cbeta+cgama
c      write (*,*) ' fpi2rnew: coefs',cepdom,cbeta,cgama
c      write (*,*) ' fpi2rnew: BWs',cBWGSr
      cfpis  =(cBWGSr(1)*cepdom+cbeta*cBWGSr(2)+cgama*cBWGSr(3))/cnorm
      cfpis1 =(cBWGSr(1)+cbeta*cBWGSr(2)+cgama*cBWGSr(3))/cnorm
c      fpi2rnewtot=cfpis *DCONJG(cfpis )
c      fpi2rnewie1=cfpis1*DCONJG(cfpis1)
c      fpi2rnewtot=abs(cfpis)
c      fpi2rnewie1=abs(cfpis1)
c      fpi2rnewtot=cfpis
c      fpi2rnewie1=cfpis1
c      write (*,*) ' fpi2rnew: ',cfpis,cfpis1
      if (iso.eq.0) then        
c        fpi2kk =fpi2rnewtot-fpi2rnewie1
       fpikk=cfpis-cfpis1
      else if (iso.eq.1) then
c        fpi2kk =fpi2rnewie1
       fpikk=cfpis1
      else 
c        fpi2kk =fpi2rnewtot
       fpikk=cfpis
      endif
c      write (*,*) ' fpi2rnew:',e,fpi2rnew
      return
      end
