      subroutine invmcuts(p,istf)
c----------------------------------------------------------------------c
c Cuts on invariant masses for the associated ttH production
c----------------------------------------------------------------------c

      use inprms
      use partcls
      use kincuts
      use qrkinds
      use prtinds

      implicit none

      integer :: istf,i,j,il1,il2
      real(dp) :: p(0:3,nepl),qqim,pij(0:3),pbij(0:3),dmh,dmh0,
     &            ptrl(1:2),ptrn(1:2),ml2,mbl2,mtran,lnim

      istf=1
      if (imbbh == 1) then
       dmh0=mbbh
       ib1=0
       ib2=0
       do i=1,nxb-1
        do j=i+1,nxb
         pij=p(:,ixb(i))+p(:,ixb(j))
         dmh=abs(sqrt((pij(0)-pij(3))*(pij(0)+pij(3))-pij(1)*pij(1)
     &             -pij(2)*pij(2))-mh)
         if (dmh < dmh0) then
          ib1=ixb(i)
          ib2=ixb(j)
          dmh0=dmh
         end if
        end do
       end do
       if (ib1 == 0) then
        istf=0
        return
       end if
      end if
      if (imnb == 1) then
       iq1=0
       iq2=0
       do i=1,nxq-1
        do j=i+1,nxq
         pij=p(:,ixq(i))+p(:,ixq(j))
         qqim=sqrt((pij(0)-pij(3))*(pij(0)+pij(3))-pij(1)*pij(1)
     &                -pij(2)*pij(2))
         if (mqq1 < qqim .and. qqim < mqq2) then
          iq1=ixq(i)
          iq2=ixq(j)
          exit
         end if
        end do
       end do
       if (iq1 == 0) then
        istf=0
        return
       end if
       if (imbqq == 1) then
        ib3=0
        do i=nisp+1,nepl
         if (imbbh == 1) then
          if (i /= ib1 .and. i /= ib2 .and. iyb(i) == i) then
           pbij=p(:,i)+pij
           if (abs(sqrt((pbij(0)-pbij(3))*(pbij(0)+pbij(3))
     &         -pbij(1)*pbij(1)-pbij(2)*pbij(2))-mt) < mbqq) then
            ib3=i
            exit
           end if
          end if
         else
          if (iyb(i) == i) then
           pbij=p(:,i)+pij
           if (abs(sqrt((pbij(0)-pbij(3))*(pbij(0)+pbij(3))
     &         -pbij(1)*pbij(1)-pbij(2)*pbij(2))-mt) < mbqq) then
            ib3=i
            exit
           end if
          end if
         end if
        end do
        if (ib3 == 0) then
         istf=0
         return
        end if
       end if
      end if
      if (imln == 1) then
       il1=0
       il2=0
       do i=1,nxl
        do j=1,nxn
         ptrl=p(1:2,ixl(i))
         ptrn=p(1:2,ixn(j))
         ml2=m(ixl(i))**2
         lnim=sqrt(ml2
     &    +2.d0*sqrt(ml2+ptrl(1)**2+ptrl(2)**2)
     &                *sqrt(ptrn(1)**2+ptrn(2)**2)
     &    -2.d0*(ptrl(1)*ptrn(1)+ptrl(2)*ptrn(2)))
         if (mln1 < lnim .and. lnim < mln2) then
          il1=ixl(i)
          il2=ixn(j)
          exit
         end if
        end do
       end do
       if (il1 == 0) then
        istf=0
        return
       end if
       if (imbln == 1) then
        ib4=0
        do i=nisp+1,nepl
         if (imbbh == 1 .and. i /= ib1 .and. i /= ib2) then
          if (imbqq == 1 .and. i /= ib3) then
           if (iyb(i) == i) then
            mbl2=(p(0,i)+p(0,il1))**2-(p(1,i)+p(1,il1))**2
     &          -(p(2,i)+p(2,il1))**2-(p(3,i)+p(3,il1))**2
            mtran=sqrt(mbl2+2.d0*sqrt(mbl2+(p(1,i)+p(1,il1))**2
     &            +(p(2,i)+p(2,il1))**2)*sqrt(p(1,il2)**2+p(2,il2)**2)
     &            -2.d0*((p(1,i)+p(1,il1))*p(1,il2)
     &                  +(p(2,i)+p(2,il1))*p(2,il2)))
            if (mt-mbln1 < mtran .and. mtran < mt+mbln2) then
             ib4=i
             exit
            end if
           end if
          else
           if (iyb(i) == i) then
            mbl2=(p(0,i)+p(0,il1))**2-(p(1,i)+p(1,il1))**2
     &          -(p(2,i)+p(2,il1))**2-(p(3,i)+p(3,il1))**2
            mtran=sqrt(mbl2+2.d0*sqrt(mbl2+(p(1,i)+p(1,il1))**2
     &            +(p(2,i)+p(2,il1))**2)*sqrt(p(1,il2)**2+p(2,il2)**2)
     &            -2.d0*((p(1,i)+p(1,il1))*p(1,il2)
     &                  +(p(2,i)+p(2,il1))*p(2,il2)))
            if (mt-mbln1 < mtran .and. mtran < mt+mbln2) then
             ib4=i
             exit
            end if
           end if
          end if
         else
          if (imbqq == 1 .and. i /= ib3) then
           if (iyb(i) == i) then
            mbl2=(p(0,i)+p(0,il1))**2-(p(1,i)+p(1,il1))**2
     &          -(p(2,i)+p(2,il1))**2-(p(3,i)+p(3,il1))**2
            mtran=sqrt(mbl2+2.d0*sqrt(mbl2+(p(1,i)+p(1,il1))**2
     &            +(p(2,i)+p(2,il1))**2)*sqrt(p(1,il2)**2+p(2,il2)**2)
     &            -2.d0*((p(1,i)+p(1,il1))*p(1,il2)
     &                  +(p(2,i)+p(2,il1))*p(2,il2)))
            if (mt-mbln1 < mtran .and. mtran < mt+mbln2) then
             ib4=i
             exit
            end if
           end if
          else
           if (iyb(i) == i) then
            mbl2=(p(0,i)+p(0,il1))**2-(p(1,i)+p(1,il1))**2
     &          -(p(2,i)+p(2,il1))**2-(p(3,i)+p(3,il1))**2
            mtran=sqrt(mbl2+2.d0*sqrt(mbl2+(p(1,i)+p(1,il1))**2
     &            +(p(2,i)+p(2,il1))**2)*sqrt(p(1,il2)**2+p(2,il2)**2)
     &            -2.d0*((p(1,i)+p(1,il1))*p(1,il2)
     &                  +(p(2,i)+p(2,il1))*p(2,il2)))
            if (mt-mbln1 < mtran .and. mtran < mt+mbln2) then
             ib4=i
             exit
            end if
           end if
          end if
         end if
        end do
        if (ib4 == 0) then
         istf=0
         return
        end if
       end if
      end if

      end subroutine invmcuts
